/*	$OpenBSD: extern.h,v 1.6 2001/01/28 19:34:27 niklas Exp $	*/
/*	$NetBSD: extern.h,v 1.2 1995/04/11 02:44:49 cgd Exp $	*/

/*
 * Copyright (C) 1997 and 1998 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*-
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)extern.h	8.2 (Berkeley) 4/4/94
 */

#include <utmp.h>

#ifndef __P
#define __P(x) x
#endif /* !__P */

void	blkfree __P((char **));
char  **copyblk __P((char **));
void	cwd __P((char *));
void	delete __P((char *));
void	dologout __P((int));
void	fatal __P((char *));
int	ftpd_pclose __P((FILE *));
FILE   *ftpd_popen __P((char *, char *));
char   *ftpd_getline __P((char *, int, FILE *));
void	ftpdlogwtmp __P((char *, char *, char *));
void	lreply __P((int, const char *, ...));
void	makedir __P((char *));
void	nack __P((char *));
void	pass __P((char *));
void	passive __P((void));
int	lpsvproto2af __P((int));
int	af2lpsvproto __P((int));
int	epsvproto2af __P((int));
int	af2epsvproto __P((int));
void	long_passive __P((char *, int));
int	extended_port __P((const char *));
void	epsv_protounsupp __P((const char *));
void	perror_reply __P((int, char *));
void	pwd __P((void));
void	removedir __P((char *));
void	renamecmd __P((char *, char *));
char   *renamefrom __P((char *));
void	reply __P((int, const char *, ...));
void	retrieve __P((char *, char *));
void	send_file_list __P((char *));
void	setproctitle __P((const char *, ...));
void	statcmd __P((void));
void	statfilecmd __P((char *));
void	store __P((char *, char *, int));
void	upper __P((char *));
void	user __P((char *));
void	yyerror __P((char *));
void	toolong __P((int));
void	ftpd_login __P((struct utmp *));
int	ftpd_logout __P((register char *));
#ifndef HAVE_STRLCPY
size_t	strlcpy __P((char *dst, const char *src, size_t siz));
#endif /* !HAVE_STRLCPY */

int	yyparse __P((void));

/* sockunion is dependent on the order of the members of the system's
 * sockaddr_in and sockaddr_in6.
 * OpenBSD:
 * struct sockaddr_in {
 *	u_int8_t    sin_len;
 *	sa_family_t sin_family;
 *	in_port_t   sin_port;
 *	struct      in_addr sin_addr;
 *	int8_t      sin_zero[8];
 * };
 * struct sockaddr_in6 {
 *	u_int8_t        sin6_len;
 *	sa_family_t     sin6_family;
 *	in_port_t       sin6_port;
 *	u_int32_t       sin6_flowinfo;
 *	struct in6_addr sin6_addr;
 *	u_int32_t       sin6_scope_id;
 * };
 * Linux:
 * struct sockaddr_in {
 *	sa_family_t sin_family;
 *	uint16_t sin_port;
 *	struct in_addr sin_addr;
 *	unsigned char sin_zero[sizeof (struct sockaddr) -
 *				sizeof (sa_family_t) -
 *				sizeof (uint16_t) -
 *				sizeof (struct in_addr)];
 * };
 * struct sockaddr_in6 {
 *	sa_family_t sin6_family;
 *	uint16_t sin6_port;
 *	uint32_t sin6_flowinfo;
 *	struct in6_addr sin6_addr;
 * };
 */
union sockunion {
	struct sockinet {
/* If we don't have the sin_len member, we must put si_len at the end */
#ifdef HAVE_SIN_LEN
		u_char si_len;
		u_char si_family;
		u_short si_port;
#else
		sa_family_t si_family;
		unsigned short int si_port;
# ifdef INET6
		char padding[sizeof(struct sockaddr_in6) - sizeof(sa_family_t) -
			     sizeof(unsigned short int)];
# else
		char padding[sizeof(struct sockaddr_in) - sizeof(sa_family_t) -
			     sizeof(unsigned short int)];
# endif /* INET6 */
		u_char si_len;
#endif /* !HAVE_SIN_LEN */
	} su_si;
	struct sockaddr_in  su_sin;
#ifdef INET6
	struct sockaddr_in6 su_sin6;
#endif /* INET6 */
};

#define su_len		su_si.si_len
#define su_family	su_si.si_family
#define su_port		su_si.si_port

/* TODO: realy make these glob flags handled nicely... */
#ifdef __GLIBC__
# ifndef GLOB_QUOTE
#  define GLOB_QUOTE 0	/* Quote special chars with \ is glibc default */
# endif
#endif /* __GLIBC__ */

#ifndef GLOB_QUOTE
#define GLOB_QUOTE 0	/* XXX this is to get it working on Solaris 8, */
#endif			/* but I haven't checked any danger!           */
#ifndef GLOB_BRACE
#define GLOB_BRACE 0
#endif /* GLOB_BRACE */
#ifndef GLOB_TILDE
#define GLOB_TILDE 0
#endif /* GLOB_TILDE */
#ifndef GLOB_LIMIT
#define GLOB_LIMIT 0
#endif /* GLOB_LIMIT */
