Name		: ftpd-tls
Version		: 20011119
Release		: pr1
Group		: Server/Network
Requires	: openssl
BuildRequires	: openssl-devel

Copyright	: GPL and BSD
Packager	: Peter 'Luna' Runestig <peter@runestig.com>
URL		: ftp://ftp.runestig.com/pub/ftpd-tls/

Summary		: ftpd with SSL/TLS support.

BuildRoot	: /tmp/%{Name}-%{Version}

%define ssldir /usr/share/ssl

Source0: ftp://ftp.runestig.com/pub/ftpd-tls/ftpd-tls.%{PACKAGE_VERSION}.tar.gz
Source1: ftpd-rsa.pem
Source2: ftpd-rsa-key.pem
Source3: ftp.xinetd


%Description
ftpd with SSL/TLS support.


%Prep
%setup -n ftpd-tls


%Build
./configure --prefix=/usr --mandir=%{_mandir} --libexecdir=/usr/sbin  \
	--enable-tls_zlib
make


%Install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT/usr/sbin/ftpd
mkdir -p $RPM_BUILD_ROOT%{ssldir}/{certs,private}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{ssldir}/certs
hash=`openssl x509 -hash -noout -in %{SOURCE1}`
ln -s `basename %{SOURCE1}` $RPM_BUILD_ROOT%{ssldir}/certs/$hash.0
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{ssldir}/private
chmod 600 $RPM_BUILD_ROOT%{ssldir}/private/*
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/xinetd.d/ftp


%Clean
rm -rf $RPM_BUILD_ROOT


%Files
%defattr(-,root,root)
%doc README.TLS draft-murray-auth-ftp-ssl-??.txt
%config %{ssldir}/certs/*
%attr(0600,root,root) %config %{ssldir}/private/*
%config /etc/xinetd.d/ftp
/usr/sbin/ftpd
%{_mandir}/man8/ftpd.8*


%ChangeLog
* Tue Nov 27 2001 Peter 'Luna' Runestig <peter@runestig.com>
- Created the whole thing, based on my earlier Caldera package. We don't like
  Caldera anymore, since their kernel config is braindamage...
