Summary: ftpd with AUTH TLS support.
Name: ftpd-tls
Version: 20000920
Release: 1
Copyright: BSD
Packager: Peter 'Luna' Runestig <peter@runestig.com>
Group: Applications/Internet
Source: ftp://ftp.runestig.com/pub/ftpd-tls/ftpd-tls.%{PACKAGE_VERSION}.tar.gz
BuildRoot: /var/tmp/ftpd-tls-root
Requires: openssl-appl

%description
ftpd-tls is a ftp server that supports TLS authentication and encryption (by the
means of the OpenSSL toolkit).
The base ftp server code is from OpenBSD 2.7. Porting to Linux and TLS
implementation by Peter 'Luna' Runestig <peter@runestig.com>.

%prep
# you must have statically linked OpenSSL installed in `/usr/local/ssl'
%setup -q -n ftpd-tls
./configure --libexecdir=/usr/local/sbin --disable-pam --with-openssl-dir=/usr/local/ssl

%build
make LDSTATIC=-static

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT/usr/local/sbin/ftpd
mkdir -p $RPM_BUILD_ROOT/usr/local/ssl/{certs,private}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/local/man/man8/ftpd.8
/usr/local/sbin/ftpd
/usr/local/ssl

%post
echo "If you don't have a TLS certificate to use with ftpd,"
echo "run the following command:"
echo "# /usr/local/ssl/misc/mk_selfsigned_cert.sh ftpd-rsa.pem"
echo "A self-signed TLS certificate will be created for you."
